Summary:        Tool to update x86/x86-64 CPU microcode.
Name:           microcode_ctl
Version:        1.17
Release:        25.4.0.3%{?dist}
Epoch:          1
Group:          System Environment/Base
License:        GPLv2+
URL:            http://www.urbanmyth.org/microcode/
Source0:        http://www.urbanmyth.org/microcode/microcode_ctl-%{version}.tar.gz
Source1:        microcode_ctl.rules
# Microcode now distributed directly by Intel, at
# http://downloadcenter.intel.com (just search for microcode)
Source2:        microcode-20161104.dat
# http://www.amd64.org/support/microcode.html
Source3:        amd-ucode-2013-11-07.tar
Source4:        disclaimer
Source10:       06-55-04
Buildroot:      %{_tmppath}/%{name}-%{version}-root
Requires(pre):  /sbin/chkconfig /sbin/service
Requires(pre):  grep gawk coreutils
ExclusiveArch:  %{ix86} x86_64

Patch1: microcode_ctl.patch
Patch2: microcode_ctl-manpage-0.patch
Patch3: microcode_ctl-1.17-getopt.patch
Patch4: microcode_ctl-1.17-hosts-only.patch
Patch5: microcode_ctl-Broadwell-fix.patch

%description
microcode_ctl - updates the microcode on Intel x86/x86-64 CPU's

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
tar xf %{SOURCE3}

%build
make CFLAGS="$RPM_OPT_FLAGS" %{?_smp_mflags}

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}/lib/udev/rules.d
mkdir -p %{buildroot}/usr/share/man/man{1,8}
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
mkdir -p %{buildroot}/lib/firmware/amd-ucode/
mkdir -p %{buildroot}/lib/firmware/intel-ucode/
mkdir -p %{buildroot}/usr/share/doc/microcode_ctl/

make DESTDIR=%{buildroot} PREFIX=%{_prefix} \
     INSDIR=/sbin MANDIR=%{_mandir}/man8 RCDIR=%{_sysconfdir} install clean

rm -rf %{buildroot}/etc/*

install -m 644 %{SOURCE1} %{buildroot}/lib/udev/rules.d/89-microcode.rules
install -m 644 %{SOURCE2} %{buildroot}/lib/firmware/microcode.dat
install -m 644 %{SOURCE4} %{buildroot}/usr/share/doc/microcode_ctl/disclaimer
install -m 644 %{SOURCE10} %{buildroot}/lib/firmware/intel-ucode/

install -m 644 amd-ucode-2013-11-07/microcode_amd.bin %{buildroot}/lib/firmware/amd-ucode/microcode_amd.bin
install -m 644 amd-ucode-2013-11-07/microcode_amd_fam15h.bin %{buildroot}/lib/firmware/amd-ucode/microcode_amd_fam15h.bin
install -m 644 amd-ucode-2013-11-07/microcode_amd_fam16h.bin %{buildroot}/lib/firmware/amd-ucode/microcode_amd_fam16h.bin
install -m 644 amd-ucode-2013-11-07/LICENSE LICENSE.microcode_amd

chmod -R a-s %{buildroot}

%post
# send the message to syslog, so it gets recorded on /var/log
if [ -e /usr/bin/logger ]; then
	/usr/bin/logger -p syslog.notice -t DISCLAIMER -f /usr/share/doc/microcode_ctl/disclaimer
fi
# also paste it over dmesg (some customers drop dmesg messages while
# others keep them into /var/log for the later case, we'll have the
# disclaimer recorded twice into system logs.
cat /usr/share/doc/microcode_ctl/disclaimer > /dev/kmsg

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
/lib/firmware/*
/lib/udev/rules.d/*
/sbin/microcode_ctl
%doc LICENSE.microcode_amd
%attr(0644,root,root) %{_mandir}/*/*
/usr/share/doc/microcode_ctl/disclaimer

%triggerun -- microcode_ctl < 1:1.17-4
/sbin/chkconfig --del microcode_ctl
exit 0

%changelog
* Wed Feb 21 2018 Todd Vierling <todd.vierling@oracle.com> - 1:1.17-25.4.0.3
- Update 50654 (06-55-04) to rev 0x2000043.

* Sat Jan 20 2018 Keshav Sharma <keshav.sharma@oracle.com> - 1:1.17-25.4.0.2
- Revert:  early microcode load to allow updating Broadwell model 79
- Revert: Make sure "modprobe microcode" is not executed on Broadwell model 79
- Revert: Run dracut upon microcode update
- Revert updated Intel 20180108 microcode for CPUIDs: {CVE-2017-5715}
  306c3 (06-3c-03 rev 0x23, Haswell);
  306d4 (06-3d-04 rev 0x28, Broadwell);
  306f2 (06-3f-02 rev 0x3b, Haswell);
  306f4 (06-3f-04 rev 0x10, Haswell);
  306e4 (06-3e-04 rev 0x42a, Ivy Bridge);
  40651 (06-45-01 rev 0x21, Haswell);
  40661 (06-46-01 rev 0x18, Haswell);
  40671 (06-47-01 rev 0x1b, Broadwell);
  406e3 (06-4e-03 rev 0xc2, Skylake);
  406f1 (06-4f-01 rev 0xb000025, Broadwell);
  50654 (06-55-04 rev 0x200003c, Skylake);
  50662 (06-56-02 rev 0x14, Broadwell);
  50663 (06-56-03 rev 0x7000011, Broadwell);
  506e3 (06-5e-03 rev 0xc2, Skylake);
  706a1 (06-7a-01 rev 0x22);
  806e9 (06-8e-09 rev 0x80, Kaby Lake);
  806ea (06-8e-0a rev 0x80);
  906e9 (06-9e-09 rev 0x80, Kaby Lake)
  906ea (06-9e-0a rev 0x80);
  906eb (06-9e-0b rev 0x80)

* Wed Jan 17 2018 Todd Vierling <todd.vierling@oracle.com> - 1:1.17-25.4.0.1
- Enable early microcode load to allow updating Broadwell model 79
- Make sure "modprobe microcode" is not executed on Broadwell model 79
- Run dracut upon microcode update
- Add updated Intel 20180108 microcode for CPUIDs: {CVE-2017-5715}
  306c3 (06-3c-03 rev 0x23, Haswell);
  306d4 (06-3d-04 rev 0x28, Broadwell);
  306f2 (06-3f-02 rev 0x3b, Haswell);
  306f4 (06-3f-04 rev 0x10, Haswell);
  306e4 (06-3e-04 rev 0x42a, Ivy Bridge);
  40651 (06-45-01 rev 0x21, Haswell);
  40661 (06-46-01 rev 0x18, Haswell);
  40671 (06-47-01 rev 0x1b, Broadwell);
  406e3 (06-4e-03 rev 0xc2, Skylake);
  406f1 (06-4f-01 rev 0xb000025, Broadwell);
  50654 (06-55-04 rev 0x200003c, Skylake);
  50662 (06-56-02 rev 0x14, Broadwell);
  50663 (06-56-03 rev 0x7000011, Broadwell);
  506e3 (06-5e-03 rev 0xc2, Skylake);
  706a1 (06-7a-01 rev 0x22);
  806e9 (06-8e-09 rev 0x80, Kaby Lake);
  806ea (06-8e-0a rev 0x80);
  906e9 (06-9e-09 rev 0x80, Kaby Lake)
  906ea (06-9e-0a rev 0x80);
  906eb (06-9e-0b rev 0x80)

* Mon Jan 15 2018 Petr Oros <poros@redhat.com> - 1:1.17-25.4
- Use right upstream source for revert
- Resolves: #1533978

* Fri Jan 12 2018 Petr Oros <poros@redhat.com> - 1:1.17-25.3
- Revert Microcode from Intel and AMD for Side Channel attack
- Resolves: #1533978

* Fri Dec 15 2017 Petr Oros <poros@redhat.com> - 1:1.17-25.2
- Update Intel CPU microde for 06-3f-02, 06-4f-01, and 06-55-04
- Add amd microcode_amd_fam17h.bin data file
- Resolves: #1527357

* Wed Jul 26 2017 Petr Oros <poros@redhat.com> - 1:1.17-25.1
- Update microcode data file to 20170707 revision.
- Resolves: #1465143

* Mon Feb 20 2017 Petr Oros <poros@redhat.com> - 1:1.17-25
- Revert microcode_amd_fam15h.bin to version from amd-ucode-2012-09-10
- Resolves: #1322525

* Tue Feb 7 2017 Petr Oros <poros@redhat.com> - 1:1.17-24
- Update microcode data file to 20161104 revision.
- Add workaround for E5-26xxv4
- Resolves: #1346045

* Tue Oct 4 2016 Petr Oros <poros@redhat.com> - 1:1.17-23
- Update microcode data file to 20160714 revision.
- Resolves: #1346045

* Wed Sep 14 2016 Petr Oros <poros@redhat.com> - 1:1.17-22
- Update amd microcode data file to amd-ucode-2013-11-07
- Resolves: #1322525

* Wed Nov 11 2015 Petr Oros <poros@redhat.com> - 1:1.17-21
- Update microcode data file to 20151106 revision.
- Resolves: #1244968
- Remove bad file permissions on /lib/udev/rules.d/89-microcode.rules
- Resolves: #1201276

* Thu Jan 29 2015 Petr Oros <poros@redhat.com> - 1:1.17-20
- Update microcode data file to 20150121 revision.
- Resolves: #1123992

* Mon Jun 30 2014 Petr Oros <poros@redhat.com> - 1:1.17-19
- Update microcode data file to 20140624 revision.
- Resolves: #1113394

* Mon May 05 2014 Petr Oros <poros@redhat.com> - 1:1.17-18
- Update microcode data file to 20140430 revision.
- Resolves: #1036240

* Mon Sep 09 2013 Anton Arapov <anton@redhat.com> - 1:1.17-17
- Update to microcode-20130906.dat
- Resolves: rhbz#1005606

* Mon Aug 26 2013 Anton Arapov <anton@redhat.com> - 1:1.17-16
- Microcode update should be skipped in virtualized environment
- Resolves: rhbz#1000317

* Thu Aug 08 2013 Anton Arapov <anton@redhat.com> - 1:1.17-15
- Update to microcode-20130808.dat
- Resolves: rhbz#915957

* Mon Oct 22 2012 Anton Arapov <anton@redhat.com> - 1:1.17-14
- Update microcode for AMD cpus to 2012-09-10
- Resolves: rhbz#867078

* Mon Sep 24 2012 Anton Arapov <anton@redhat.com> - 1:1.17-13
- Update to microcode-20120606v2.dat
- Resolves: rhbz#818096

* Mon Aug 27 2012 Anton Arapov <anton@redhat.com> - 1:1.17-12
- Fix udev rule
- Resolves: rhbz#740932
- Update to microcode-20120606.dat
- Resolves: rhbz#818096

* Fri Feb 17 2012 Anton Arapov <anton@redhat.com> - 1:1.17-11
- Update microcode for AMD cpus to 20120117
- Resolves: rhbz#787757

* Wed Feb 15 2012 Anton Arapov <anton@redhat.com> - 1:1.17-10
- Fix buffer overflow
- Resolves: rhbz#768803
- Update to microcode-20111110.dat
- Resolves: rhbz#736266

* Wed Oct 05 2011 Anton Arapov <anton@redhat.com> - 1:1.17-9
- Update to microcode-20110915.dat
- Resolves: rhbz#696582

* Thu Jul 21 2011 Anton Arapov <anton@redhat.com> - 1:1.17-8
- Revert: Minor fix of the udev rule
- Relates: rhbz#682668

* Wed Jul 20 2011 Anton Arapov <anton@redhat.com> - 1:1.17-7
- Minor fix of the udev rule
- Include microcode update for AMD cpus
- Resolves: rhbz#682668

* Wed Jul 20 2011 Anton Arapov <anton@redhat.com> - 1:1.17-6
- Update to microcode-20110428.dat
- Resolves: rhbz#696582

* Thu Mar 24 2011 Anton Arapov <anton@redhat.com> - 1:1.17-5
- fix memory leak.
- Resolves: rhbz#684009

* Wed Nov 24 2010 Anton Arapov <anton@redhat.com> - 1:1.17-4
- Update to microcode-20101123.dat
- Make microcode_ctl event driven
- Resolves: rhbz#578107

* Tue Feb 23 2010 Anton Arapov <anton@redhat.com> - 1:1.17-3
- Update to microcode-20100209.dat [488319]

* Fri Feb 19 2010 Kyle McMartin <kyle@redhat.com> - 1:1.17-2
- Don't use a CVS release for RHEL, otherwise it'll always be a branch
  and irritating.
- Fix syntax error in microcode_ctl.init.
- Resolves: rhbz#552246.

* Mon Nov 30 2009 Dennis Gregorovic <dgregor@redhat.com> - 1:1.17-1.41.1
- Rebuilt for RHEL 6

* Wed Sep 30 2009 Dave Jones <davej@redhat.com>
- Update to microcode-20090927.dat

* Fri Sep 11 2009 Dave Jones <davej@redhat.com>
- Remove some unnecessary code from the init script.

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:1.17-1.52.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Jun 25 2009 Dave Jones <davej@redhat.com>
- Shorten sleep time during init.
  This really needs to be replaced with proper udev hooks, but this is
  a quick interim fix.

* Wed Jun 03 2009 Kyle McMartin <kyle@redhat.com> 1:1.17-1.50
- Change ExclusiveArch to i586 instead of i386. Resolves rhbz#497711.

* Wed May 13 2009 Dave Jones <davej@redhat.com>
- update to microcode 20090330

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:1.17-1.46.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Fri Sep 12 2008 Dave Jones <davej@redhat.com>
- update to microcode 20080910

* Tue Apr 01 2008 Jarod Wilson <jwilson@redhat.com>
- Update to microcode 20080401

* Sat Mar 29 2008 Dave Jones <davej@redhat.com>
- Update to microcode 20080220
- Fix rpmlint warnings in specfile.

* Mon Mar 17 2008 Dave Jones <davej@redhat.com>
- specfile cleanups.

* Fri Feb 22 2008 Jarod Wilson <jwilson@redhat.com>
- Use /lib/firmware instead of /etc/firmware

* Wed Feb 13 2008 Jarod Wilson <jwilson@redhat.com>
- Fix permissions on microcode.dat

* Thu Feb 07 2008 Jarod Wilson <jwilson@redhat.com>
- Spec cleanup and macro standardization.
- Update license
- Update microcode data file to 20080131 revision.

* Mon Jul  2 2007 Dave Jones <davej@redhat.com>
- Update to upstream 1.17

* Thu Oct 12 2006 Jon Masters <jcm@redhat.com>
- BZ209455 fixes.

* Mon Jul 17 2006 Jesse Keating <jkeating@redhat.com>
- rebuild

* Fri Jun 16 2006 Bill Nottingham <notting@redhat.com>
- remove kudzu requirement
- add prereq for coreutils, awk, grep

* Thu Feb 09 2006 Dave Jones <davej@redhat.com>
- rebuild.

* Fri Jan 27 2006 Dave Jones <davej@redhat.com>
- Update to upstream 1.13

* Fri Dec 16 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt for new gcj

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Mon Nov 14 2005 Dave Jones <davej@redhat.com>
- initscript tweaks.

* Tue Sep 13 2005 Dave Jones <davej@redhat.com>
- Update to upstream 1.12

* Wed Aug 17 2005 Dave Jones <davej@redhat.com>
- Check for device node *after* loading the module. (#157672)

* Tue Mar  1 2005 Dave Jones <davej@redhat.com>
- Rebuild for gcc4

* Thu Feb 17 2005 Dave Jones <davej@redhat.com>
- s/Serial/Epoch/

* Tue Jan 25 2005 Dave Jones <davej@redhat.com>
- Drop the node creation/deletion change from previous release.
  It'll cause grief with selinux, and was a hack to get around
  a udev shortcoming that should be fixed properly.

* Fri Jan 21 2005 Dave Jones <davej@redhat.com>
- Create/remove the /dev/cpu/microcode dev node as needed.
- Use correct path again for the microcode.dat.
- Remove some no longer needed tests in the init script.

* Fri Jan 14 2005 Dave Jones <davej@redhat.com>
- Only enable microcode_ctl service if the CPU is capable.
- Prevent microcode_ctl getting restarted multiple times on initlevel change (#141581)
- Make restart/reload work properly
- Do nothing if not started by root.

* Wed Jan 12 2005 Dave Jones <davej@redhat.com>
- Adjust dev node location. (#144963)

* Tue Jan 11 2005 Dave Jones <davej@redhat.com>
- Load/Remove microcode module in initscript.

* Mon Jan 10 2005 Dave Jones <davej@redhat.com>
- Update to upstream 1.11 release.

* Sat Dec 18 2004 Dave Jones <davej@redhat.com>
- Initial packaging, based upon kernel-utils.

